#define MidiChannel 1
;#define ICD
;#define MIDITHROUGHTEST
#include "../midiLatch.asm"

		CBLOCK	0x020
		SforzandoMode		;to save WREG during interrupt
		SforzandoTimer
		SforzandoTime
		ENDC

MidiInNoteOn2
	return
MidiInNoteOff2
	return

MidiInCtrlChange:
		movlw	0x07; 			CC Volume
		subwf	MidiByte1,0;
		bz		MidiInCCVol;
		movlw	0x7B; 			CC NotesOff
		subwf	MidiByte1,0;
		bz		MidiInCCAllNotesOff;
		movlw	0x0A;			CC MidiInCCSforzandoMode
		subwf	MidiByte1,0;
		bz		MidiInCCSforzandoMode;
		movlw	0x0B;			CC MidiInCCSforzandoTime
		subwf	MidiByte1,0;
		bz		MidiInCCSfzTime;
	return

MidiInCCVol:
		movf	MidiByte2,W
		XORLW	0x7F
		movwf	CCPR1L;
	return
	
MidiInCCSfzTime
		MOVF	MidiByte2,W	
		MOVWF	SforzandoTime
	return

MidiInCCSforzandoMode:
		movff	MidiByte2,SforzandoMode	
		movlw	0x00
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x05
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x06
		subwf	SforzandoMode,W
		bz		SforzandoModeUP
		movlw	0x09
		subwf	SforzandoMode,W
		bz		SforzandoModeOP
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		SforzandoModeUP
		movlw	0x10
		subwf	SforzandoMode,W
		bz		SforzandoModeLFO
	RETURN

SforzandoModeOP:
		BCF			LATC,4
		BCF			LATC,5
	RETURN

SforzandoModeUP:
		BSF		LATC,4
		BSF		LATC,5
	RETURN

Timer1ISR:
		BCF		PIR1,TMR1IF
		movlw	0x0A
		subwf	SforzandoMode,W
		bz		Timer1ISRTremolo;		
	BRA		EndLowInt
	
Timer1ISRTremolo:
		DECFSZ	SforzandoTimer
		BRA		EndLowInt	
		BTG		LATC,4
		BTG		LATC,5
		MOVFF	SforzandoTime,SforzandoTimer
	BRA		EndLowInt	

SforzandoModeLFO:
	RETURN

UserInit:
; pwm init
		movlw	0x80;
		movwf	PR2;
		movlw	0x7F;
		movwf	CCPR1L;
		movlw	0x01;
		movwf	TMR2;
		movlw	0x04;
		movwf	T2CON;
		movlw	0x0C;
		movwf	CCP1CON;
		CLRF	SforzandoMode
	
		; Timer1 setup
		MOVLW	0x31
		MOVWF	T1CON;
		BCF		PIR1,TMR1IF
		BCF		IPR1,TMR1IP	; Timer 1 is low priority
		BSF		PIE1,TMR1IE	; Timer 1 interupt enable
		BSF		INTCON,PEIE ;
		BSF		RCON, IPEN ; interrupt priorities enabled
		BSF		PIR1,TMR1IF
	RETURN


MidiInChannelPressure:
		MOVFF	MidiByte1, 	SforzandoTime;
	RETURN

MidiInProgramChange:
MidiInRTReset:
MidiInRTActiveSense:
MidiInRTStop:
MidiInRTContinue:
MidiInRTStart:
MidiInRTTick:
MidiInRTClock:
MidiInTuneRequest:
MidiInAfterTouch:
MidiInPitchWheel:
MidiInSysExStart:
MidiInSysExByte:
MidiInSysExEnd:
	RETURN


;*************************************************************
;  latch pointer per note
	org 1000h	;	
NoteLatchPtr:
	DB	0,0,0,0,0,0,0,0; 0..7
	DB	0,0,0,0,0,0,0,0; 8..
	DB	0,0,0,0,0,0,0,0; 16..
	DB	0,0,0,0,0,0,0,ExtLatHData; 24..
	DB	0,0,0,0	;32..
	DB	ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData,ExtLatAData; 36..
	DB	ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData,ExtLatBData; 44..
	DB	ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData,ExtLatCData; 52..
	DB	ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData,ExtLatDData; 60..
	DB	ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData,ExtLatEData; 68..
	DB	ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData,ExtLatFData; 76..
	DB	ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData,ExtLatGData; 84..
	DB	ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,ExtLatHData,0; 92..
	DB	0,0,0,0; 100..
	DB	0,0,0,0,0,0,0,0; 104..
	DB	0,0,0,0,0,0,0,0; 112..
	DB	0,0,0,0,0,0,0,0; 120..127

	org 1100h	;	
NoteLatchOnOrMask:
	DB	0,0,0,0,0,0,0,0; 0..7
	DB	0,0,0,0,0,0,0,0; 8..
	DB	0,0,0,0,0,0,0,0; 16..
	DB	0,0,0,0,0,0,0,0x01; 24..
	DB	0,0,0,0; 32 ..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 36..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 44..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 52..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 60..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 68..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 76..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01; 84..
	DB	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0; 92..
	DB	0,0,0,0; 100..
	DB	0,0,0,0,0,0,0,0; 104..
	DB	0,0,0,0,0,0,0,0; 112..
	DB	0,0,0,0,0,0,0,0; 120..127

	org 1200h	;	
NoteLatchOffAndMask:
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 0..7
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 8..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 16..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE; 24..
	DB	0xFF,0xFF,0xFF,0xFF; 28..	
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 36..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 44..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 52..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 60..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 68..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 76..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 84..
	DB	0x7F,0xBF,0xDF,0xEF,0xF7,0xFB,0xFD,0xFE; 92..
	DB	0xFF,0xFF,0xFF,0xFF; 100..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 104..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 112..
	DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF; 120..127


	END
